//客户端传参识别，close_lazyload和url_prefix可以由客户端在<head>内特殊指定
if(typeof close_lazyload == 'undefined'){
	close_lazyload = false;
}
if(typeof url_prefix == 'undefined'){
	url_prefix = "content://com.ss.android.sdk.minusscreen.app.ImageProvider/";
}

//客户端从服务端content/full接口中提取出的origin图数据，在<head>底部注入为image_detail变量
if(typeof image_detail == 'undefined'){
	image_detail = [];
}

//客户端从服务端content/full接口中提取出的thumb图数据，在<head>底部注入为thumb_image变量
if(typeof thumb_image == 'undefined'){
	thumb_image = [];
}

//
var android21 = /android.*2.1/gi.test(navigator.userAgent),
	prefer_thumb = false,
	img_type = "origin",
	font_size = "m",
	IMG_NIGHT_OPACITY = 0.4,
	night_mode = 0,
	img_opacity = 1,
	show_video = 1,
	group_id = 0,
	imgGroup = [],
	imgAllLoaded = false,
	imgs = [],
	article,
	imageShown,
	trigger,
	store = [],//lazyload container
	offset = 100,//lazyload screen offset
	throttle = 150,//lazyload timeout
	poll,//lazyload settimeout id
	from_thumb_to_large = false,//标记是否在2G/3G网络的小图模式下点击“显示大图”
	store_origin = [],//在2G/3G网络的小图模式下点击“显示大图”，备用
	profile = document.getElementById('profile'),//pgc名片容器
	subscribe_btn = document.getElementById('subscribe'),//订阅按钮
	autoplayed = false,
	videos = [],
	isUsingHttpToLoadImage = image_detail.length != 0; //如客户端提供有效image_detail，则视为需要用http加载图片。也包括本身无图页面

// add css class to element
function add_elt_class(elt, cls) {
	if (!elt || !cls)
		return false;
	try {
		var clazz = elt.getAttribute("class");
		if (clazz == null)
			clazz = "";
		var has = false;
		var clazzes = clazz.split(" ");
		for (var i = 0; i < clazzes.length; i++) {
			if (clazzes[i] == cls) {
				has = true;
				break;
			}
		}
		if (!has) {
			if (clazz.length > 0)
				clazz = clazz.concat(" ", cls);
			else
				clazz = cls;
			elt.setAttribute("class", clazz);
			return true;
		}
	} catch (e) {
	}
	return false;
}
// delete a css class of element
function del_elt_class(elt, cls) {
	if (!elt || !cls)
		return false;
	try {
		var clazz = elt.getAttribute("class");
		if (clazz == null)
			return false;
		var has = false;
		var clazzes = clazz.split(" ");
		clazz = ""
		for (var i = 0; i < clazzes.length; i++) {
			if (clazzes[i] == cls) {
				has = true;
				continue;
			} else {
				clazz = clazz.concat(" ", clazzes[i]);
			}
		}
		if (has) {
			elt.setAttribute("class", clazz);
			return true;
		}
	} catch (e) {
	}
	return false;
}

function has_elt_class(elt, cls) {
	if (!elt || !cls)
		return false;
	try {
		var clazz = elt.getAttribute("class");
		if (clazz == null)
			return false;
		var clazzes = clazz.split(" ");
		for (var i = 0; i < clazzes.length; i++) {
			if (clazzes[i] == cls) {
				return true;
			}
		}
	} catch (e) {
	}
	return false;
}

function set_elt_text(elt, t) {
	if (elt)
		elt.textContent = t;
}

function get_elt_text(elt) {
	if (elt)
		return elt.textContent;
	else
		return null;
}

function init_table(){
	var tables = document.querySelectorAll("table");
	for(var i=0; i<tables.length; i++){
		var t = tables[i];
		var tableimgs = t.querySelectorAll(".image");
		if(!tableimgs.length){
			add_elt_class(t, "border");
			//安卓平台还没时间做wrap,故注释掉
			//is_mobile && t.wrap("<div class='horizontal_scroll'/>")
			//以下代码为4.5版本新增，但暂时不放开，待PM确认
			//问题1：安卓不能局部bytedance://disable_swipe，故右滑手势会让整个页面退出
			//问题2：安卓部分系统不触发touchend，不方便实现touchend时swipe.style.opacity = 1
			/*var coords = t.getBoundingClientRect();
			var maxWidth = article.offsetWidth;
			if(coords.width > maxWidth){
				var newTable = document.createElement('div'),
					swipe = document.createElement('div');
				swipe.className = 'swipe_tip';
				swipe.innerHTML = '左滑查看更多';
				newTable.className = 'horizontal_scroll';
				newTable.appendChild(t.cloneNode(true));
				newTable.appendChild(swipe);
				newTable.addEventListener('touchstart',function(){swipe.style.opacity = 0;},false);
				t.parentNode.replaceChild(newTable,t);
			}*/
		};
	}
};

function recalImgSize() {
	var maxWidth = article.offsetWidth;
	for(i=0; i<imgs.length; i++) {
		var _this = imgs[i]; 
		var h = _this.getAttribute("height");
		var w = _this.getAttribute("width");
		
		w1 = Math.min(w,maxWidth);
		var h1 = parseInt(h*w1/w);
		if(h1 == 0){h1 = 200};
		
		_this.setAttribute("s_width",w1);
		_this.setAttribute("s_height",h1);
	}
}

function show_large_image(parent) {
	setTimeout(function() {
		do_show_large_image(parent);
	}, 100);
}

function do_show_large_image(parent) {
	var is_offline = has_elt_class(parent, "offline");
	revert_large_href(parent);
	if (is_offline) {
		del_elt_class(parent, "thumb");
		del_elt_class(parent, "offline");
	}
	add_elt_class(parent, "loading");
	var img = null;
	var img_a = parent.querySelectorAll('img');
	if (img_a && img_a.length > 0) {
		img = img_a[0];
	}
	if (img != null) {
		var n = null;
		if (img_a && img_a.length > 1) {
			n = img_a[1];
		}
		if (n != null)
			return;
		// remove thumb img if it's not compelete
		if (img.naturalWidth == 0) {
			parent.removeChild(img);
		}
	}
	var index = parent.getAttribute("ss_index");
	var h = parent.getAttribute("s_height");
	var w = parent.getAttribute("s_width");

	var src = '';
	if(isUsingHttpToLoadImage){
		src = parent.getAttribute("origin_src") || '';
	}else{
		var src_path = parent.getAttribute("zip_src_path");
		src = url_prefix + "getimage/origin/" + src_path + "/"  + group_id + "/" + index;
	}
	
	var t = document.createElement('div');
	t.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' src='"+src+"' alt_src='"+src+"' width='1' height='1'/>";
	var o = t.firstElementChild;
	t.removeChild(o);
	parent.appendChild(o);
	if (!is_offline) {
		var spinner = document.createElement("i");
		spinner.className = 'spinner';
		parent.appendChild(spinner);
	}
	setTimeout(function(){
		var event = "bytedance://";
		if (is_offline) {
			event += "show_image";
		} else {
			event += "origin_image";
		}
		event += "?index=" + index;
		window.location.href = event;
	}, 500);
	/*
	parent.style.width = w + "px";
	parent.style.height = h + "px";
	parent.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' src='"+src+"' width='"+w+"' height='"+h+"'/>";
  */
}

large_href_handler = function(e) {show_large_image(this); e.preventDefault();};
function use_large_href(a) {
	if (a.getAttribute("ss_href")){
		a.setAttribute("href", "javascript:void(0)");
		a.addEventListener("click", large_href_handler, false);
	}
}
function revert_large_href(a) {
	a.removeEventListener("click", large_href_handler, false);
	if (a.getAttribute("ss_href"))
		a.setAttribute("href", a.getAttribute("ss_href"));
}

/**
* 从全局变量image_detail或thumb_image返回相应的图片http地址
* @param {string} type 图片模式：origin或thumb
* @param {number} index 图片在正文中的索引
* @param {number} cdn_sno 0~2，目前服务端对每张图片提供3个cdn版本，可用于图片加载失败后，替换cdn重试
*/
function getImageHttpSrc(type, index, cdn_sno){
	var obj = null,
		src = '';

	if(type == 'origin'){
		obj = image_detail[index];
	}else if(type == 'thumb'){
		obj = thumb_image[index];
	}

	if(obj){
		if(cdn_sno === 0){
			//直接从obj的属性字段url中获取，也等同于url_list中的第一个值
			src = obj["url"] ||'';
		}else{
			//尝试从obj的url_list中提取
			var url_list = obj["url_list"]
			if(url_list instanceof Array){
				var sub_obj = url_list[cdn_sno];
				if(sub_obj && (typeof sub_obj == 'object')){
					src = sub_obj["url"] || '';
				}
			}
		}
	}
	return src;
}

function show_images(type){
	ok = false;
	if (type === 'origin') {
		if ( trigger){
			trigger.style.display = "none";
		}
		imageShown = true;
		ok = true;
	} else if (type === 'thumb') {
		ok = true;
	} else if (type === 'none') {
		ok = true;
	}
	if (!ok)
		return;
	var maxWidth = article.offsetWidth;
	for (var i = imgs.length - 1; i >= 0 ;i--) {
		var parent = imgs[i];
		var h = parent.getAttribute("s_height");
		var w = parent.getAttribute("s_width");
		var src = '';

		if (type === 'thumb') {
			add_elt_class(parent, 'thumb');
			h = parent.getAttribute("thumb_height");
			w = parent.getAttribute("thumb_width");
			if (w > maxWidth) {
				var w1 = maxWidth;
				var h1 = parseInt(h * w1 / w);
				w = w1;
				h = h1;
			}
			use_large_href(parent);
		}

		parent.style.width = w + "px";
		parent.style.height = h + "px";

		if(isUsingHttpToLoadImage){
			//采用http加载图片时，无图模式在绑定点击加载大图事件后立即返回，不进行下面的“无图模式下尝试加载本地缓存”动作
			if(type == 'none'){
				add_elt_class(parent, "offline");
				use_large_href(parent);
				continue;
			}
			if(type == 'origin'){
				src = parent.getAttribute("origin_src");
			}else if(type == 'thumb'){
				src = parent.getAttribute("thumb_src");
			}
			if(!src){
				continue;
			}
		}else{
			del_elt_class(parent, "offline");
			var src_path = parent.getAttribute("zip_src_path");
			src = url_prefix + "getimage/" + type +  "/" + src_path + "/"  + group_id + "/" + i;
		}

		add_elt_class(parent, "loading");

		if(from_thumb_to_large){
			//当从2G、3G环境的小图模式点击”显示大图“时，把已显示的小图尺寸调整为要显示的大图尺寸进行占位
			//避免2G、3G网络不好，小图删除后，大图又未加载完成时的空白状态
			var p = parent.firstElementChild;
			if (p != null && p.tagName == 'IMG') {
				p.style.width = w + "px";
				p.style.height = h + "px";
			}
		}
		//parent.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' src='"+src+"' width='"+w+"' height='"+h+"'/>";
		if(close_lazyload){
			parent.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' src='"+src+"' width='"+w+"' height='"+h+"'/>";
		}else{
			if(from_thumb_to_large){
				//如果部分图片已经通过点击呈现为大图，这里也再次处理一下；相对冗余一点
				var t = document.createElement('div')
				t.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' alt_src_origin='"+src+"' width='"+w+"' height='"+h+"'/>";
				var o = t.firstElementChild;
				t.removeChild(o)
				parent.appendChild(o);
			}else{
				parent.innerHTML = "<img onload='appendimg.call(this)' style='opacity:0' onerror='errorimg.call(this)' alt_src='"+src+"' width='"+w+"' height='"+h+"'/>";
			}
		}
		if (type == 'thumb')
			toggleGifState(parent, true);
	};
};

/**
* 图片加载回调 —— 由客户端调用
* 当img的src以getimage/xxx（xxx取值origin/thumb）等形式进行获取时，客户端先从缓存中获取，失败时会触发img的errorimg事件，
* 但是，此时客户端会进一步去下载该图片，下载成功后通过image_load_cb 修改当前<img>元素。
* 所以，在img的errorimg事件中一定不能手动删除加载失败的<img>节点。
*
* 如果正文图片通过http地址加载，此处image_load_cb不会被客户端调用
*
* @param {number} i 图片索引
* @param {boolean} ok 是否成功
* @param {boolean} is_large 是否为大图
*/
function image_load_cb(i, ok, is_large) {
	if (i < 0 || i >= imgs.length)
		return;
	var parent = imgs[i];
	var img_a = parent.querySelectorAll('img');
	var _this = null;
	if (img_a && img_a.length > 0) {
		_this = img_a[0];
	}
	if (_this == null)
		return;
	var large_img = null;
	if (img_a && img_a.length > 1) {
		large_img = img_a[1];
	}
	var src_path = parent.getAttribute("zip_src_path");
	if (large_img != null) {
		if (is_large) {
			if (ok) {
				var src = url_prefix + "image/origin/" + src_path;
				large_img.setAttribute("src", src);
			} else {
				parent.removeChild(large_img);
			}
		} else {
			if (ok && _this.src.indexOf("/getimage/") > 0) {
				var src = url_prefix + "image/thumb/" + src_path;
				_this.setAttribute("src", src);
			}
		}
		return;
	}
	if (_this.src.indexOf("/getimage/") < 0)
		return;
	var offline = false;
	var p;
	if (_this.src.indexOf("/getimage/origin/") > 0) {
		p = "image/origin/"
	} else if (_this.src.indexOf("/getimage/thumb/") > 0) {
		p = "image/thumb/";
	} else {
		offline = true;
		if (is_large) {
			p = "image/origin/";
		} else {
			p = "image/thumb/";
		}
	}
	var src = url_prefix + p + src_path;
	if (ok) {
		_this.setAttribute("src", src);
	} else {
		del_elt_class(parent, "loading");
	}
};

function toggleGifState(holder, show){
	if(!holder) return;
	if(holder.getAttribute("type") !== 'gif') return;
	var gif_play  = holder.querySelector(".gif_play");
	var gif_label = holder.querySelector(".gif_label");
	if (show) {
		if (!gif_play) {
			gif_play = document.createElement("i");
			gif_play.className = 'gif_play';
			holder.appendChild(gif_play);
		}
		/*if (!gif_label) {
			gif_label = document.createElement("i");
			gif_label.className = 'gif_label';
			holder.appendChild(gif_label);
		}*/
	} else {
		if(gif_play){
			gif_play.parentNode.removeChild(gif_play);
		}
		if (gif_label) {
			gif_label.parentNode.removeChild(gif_label);
		}
	}
};

//两个callback
function appendimg(){
	var parent = this.parentNode;
	var s_w = parent.getAttribute("s_width");
	var s_h = parent.getAttribute("s_height");
	var n_w = this.naturalWidth;
	var n_h = this.naturalHeight;
	var is_large = false;
	if (n_w == parent.getAttribute("width") && n_h == parent.getAttribute("height")) {
		is_large = true;
		if (this.getAttribute("width") != parent.getAttribute("s_width")) {
			parent.style.width = s_w + "px";
			parent.style.height = s_h + "px";
			this.style.width = s_w + "px";
			this.style.height = s_h + "px";
		}else if(from_thumb_to_large){
			parent.style.width = s_w + "px";
			parent.style.height = s_h + "px";
			this.style.width = s_w + "px";
			this.style.height = s_h + "px";
		}
		del_elt_class(parent, "thumb");
		del_elt_class(parent, "offline");
		revert_large_href(parent);
	} else if (n_w > 0 && n_h > 0) {
		var maxWidth = article.offsetWidth;
		var w1 = Math.min(n_w, maxWidth);
		var h1 = parseInt(n_h * w1 / n_w);
		parent.style.width = w1 + "px";
		parent.style.height = h1 + "px";
		this.style.width = w1 + "px";
		this.style.height = h1 + "px";
	} else {
			parent.style.width = "120px";
			parent.style.height = "auto";
			this.style.width = "120px";
			this.style.height = "auto";
	}
	if (!is_large) {
		if (this.src.indexOf("getimage/none") > 0) {
			use_large_href(parent);
		}
	}
	this.style.opacity = img_opacity;
	var p = parent.firstElementChild;
	if (p != null && p.tagName == 'IMG' && p != this) {
		parent.removeChild(p);
	}
	var spinner = parent.querySelector(".spinner");
	if (spinner) {
		spinner.parentNode.removeChild(spinner);
	}
	if (is_large) {
		toggleGifState(parent, false);
	}
	del_elt_class(parent, "loading");
};

function errorimg(){
	var parent = this.parentNode;

	if (this.src.indexOf(url_prefix + "getimage/none/") == 0) {
		del_elt_class(parent, "loading");
		add_elt_class(parent, "offline");
		use_large_href(parent);
	} else if (this.src.indexOf(url_prefix + "image/") == 0 || isUsingHttpToLoadImage) {
		var p = parent.firstElementChild;
		var spinner = parent.querySelector('.spinner');
		if (p != null && p.tagName == 'IMG' && p != this && spinner != null) {
			spinner.parentNode.removeChild(spinner);
		}
		del_elt_class(parent, "loading");
		del_elt_class(parent, "offline");
	}else{
		//loading状态保持，客户端尝试去线上继续下载图片，并且在image_load_cb最终确定图片的加载状态
	}
};
//end callback

function appendVideoImg(){
	var pNode = this.parentNode;
	pNode && (pNode.style.backgroundImage = 'none');
}

function errorVideoImg(){
	var pNode = this.parentNode;
	if(pNode){
		pNode.removeChild(this);
	}
}

//字体大小,三个参数s,m,l(small,middle,large)
function setFontSize(s){
	if(["s","m","l","xl"].indexOf(s) > -1) {
		del_elt_class(document.body, "font_s");
		del_elt_class(document.body, "font_m");
		del_elt_class(document.body, "font_l");
		del_elt_class(document.body, "font_xl");
		add_elt_class(document.body, "font_"+s);
	}	
}

function initVars(){
	article = document.getElementsByTagName("article")[0];
	imageShown = false;
	imgGroup = [];
	imgAllLoaded = false;
	imgs = document.getElementsByClassName("image");
	trigger = document.getElementById("toggle_img");
	from_thumb_to_large = false;
	videos =  document.getElementsByClassName("custom-video");
	
	for (var i = 0; i < imgs.length; i++) {
		var a = imgs[i];
		a.setAttribute("ss_index", i);
		href = a.getAttribute("href");
		if (href && href.indexOf("bytedance://large_image") == 0){
			a.setAttribute("ss_href", href);
		}
		//初始化图片的origin/thumb模式的http地址，只在需要http方式加载图片时候初始化
		if(isUsingHttpToLoadImage){
			var thumb_src = getImageHttpSrc('thumb', i, 0),
				origin_src = getImageHttpSrc('origin', i, 0);
			a.setAttribute("thumb_src", thumb_src);
			a.setAttribute("origin_src", origin_src);
		}
	}
	
	metas = document.getElementsByTagName("meta");
	for (var i = 0; i < metas.length; i++) {
		var m = metas[i];
		var name = m.name.toLowerCase();
		var c = m.getAttribute("content");
		if (name == "load_image") {
			img_type = c;
		} else if (name == "font_size") {
			font_size = c;
		} else if (name == "group_id") {
			group_id = c;
		} else if (name == "night_mode"){
			night_mode = parseInt(c);
		} else if (name == "show_video"){
			show_video = parseInt(c);
		}
	};

	if (request("tt_image"))  img_type = request("tt_image");
	if (request("tt_font")) font_size = request("tt_font");
	if (request("tt_groupid")) group_id = request("tt_groupid");
	if (request("tt_daymode")) night_mode = !parseInt(request("tt_daymode"));
	if (request("tt_video")) show_video = parseInt(request("tt_video"));
	
	if(hash("tt_daymode")) night_mode = !parseInt(hash("tt_daymode"));
	if(hash("tt_font")) font_size = hash("tt_font");
	if(hash("tt_image")) img_type = hash("tt_image");
	
	if(night_mode) {
		showNightMode();
		img_opacity = IMG_NIGHT_OPACITY;
	}
	
	if(close_lazyload && imgs.length > 10){//对于“关闭懒加载”的wifi情形，当页面图片个数超过10幅时，强制打开懒加载
		close_lazyload = false;
	}
}

function showImages() {
	recalImgSize();
	
	show_images(img_type);
}

//取代上面一个函数，新增read_content事件
function initScrollEvents(){
	var doubleinnerHeight = innerHeight*2;
	var scrollOneScreen = document.height <= innerHeight;
	var scrollDoubleScreen = document.height <= doubleinnerHeight;
	var scrollBottom = false;
	if(!scrollBottom && document.height <= innerHeight){
		window.location.href = "bytedance://finish_content";
		scrollBottom = true;
	}else{
		window.onscroll = function(){
			if(!scrollOneScreen && (scrollY > innerHeight)){
				//console.log("滚过一屏");
				window.location.href = "bytedance://read_content";
				scrollOneScreen = true;
			};
			
			if(!scrollDoubleScreen && (scrollY > doubleinnerHeight)){
				//console.log("滚过两屏");
				window.location.href = "bytedance://finish_content";
				scrollDoubleScreen = true;
			};		
			
			//修复部分android不能自动加载的问题
			if(!scrollDoubleScreen && !scrollBottom && scrollY > document.height - innerHeight - 5){
				window.location.href = "bytedance://finish_content";
				scrollBottom = true;
			};
		}
	}
}

//lazyload begin
function init_lazyload(){
	store = [];
	var nodes = document.querySelectorAll('[alt_src]');
	for(var i = 0; i < nodes.length; i++){
		store.push(nodes[i]);
	}
	if(from_thumb_to_large){
		store_origin = [];
		var nodes = document.querySelectorAll('[alt_src_origin]');
		for(var i = 0; i < nodes.length; i++){
			store_origin.push(nodes[i]);
		}
	}
}
function _inView(element) {
    var coords = element.getBoundingClientRect(); 
    return ((coords.top >= 0 && coords.left >= 0 && coords.top) <= (window.innerHeight || document.documentElement.clientHeight) + offset);
}
function _pollImages(){
	var length = store.length;
    if (length > 0){
      for (var i = 0; i < length; i++) {
        var self = store[i];
        if (self && _inView(self)) {
			if(from_thumb_to_large){
				var alt_src = store_origin[i].getAttribute('alt_src_origin');
				store_origin[i].src = alt_src;
				store.splice(i, 1);
				store_origin.splice(i, 1);
				length = store.length;
				i--;
			}else{
		  		var alt_src =self.getAttribute('alt_src');
		  		self.src = alt_src;
          		store.splice(i, 1);
          		length = store.length;
          		i--;
			}
        }
      }
    }else{
		document.removeEventListener('scroll',_pollImages);
	}
}
//lazyload end
domload = function(){
	initVars();
	
	//字体自动设置
	setFontSize(font_size);
	
	showVideo(show_video);//已废弃？待确认后删除
	
	showCustomVideo();//app4.5+
	
	if(android21){
		add_elt_class(document.getElementsByTagName("body")[0], "icon1x");	
	};

	// postpone calculate image size, 'article' may not finish layout
	// article width is 0 at this point on some device.
	if(img_type === "origin") {
		if (trigger) trigger.style.display = "none";
	}
	setTimeout(function() {
		showImages();
		initScrollEvents();
		if(!close_lazyload){
			init_lazyload();//懒加载初始化
			_pollImages();//首次懒加载
			document.addEventListener("scroll",_pollImages,false);
		}
	}, 100);
	
	init_table();
	
	fixHref();
	try {
		fixSourceUrlHref();
	} catch (e) {}
	
	pgc_click_events();//统计pgc导航的点击事件
	subscribe_click_events();//订阅、取消订阅
	video_click_events();//视频点击
	
	if(typeof videoAutoPlayCallback == 'function'){
		videoAutoPlayCallback();
	}
};

document.addEventListener("DOMContentLoaded",domload,false);
//document.addEventListener("scroll",_pollImages,false);

//in detail-page,when change daymode,set img_opacity to the right value for all successfully loaded imgs.
//and used for the last imgs preparing for loading.
function changeImgOpacity(adjust_opacity){
	var true_img_nodes = document.getElementsByTagName("img");
	for(var i=0;i<true_img_nodes.length;i++){
		var cur_img = true_img_nodes[i];
		var img_src = cur_img.getAttribute('src');
		if(img_src && cur_img.style.opacity >0){
			cur_img.style.opacity = adjust_opacity;
		}
	}
}

function showNightMode(){
	var b = document.querySelector("body");
	var cn = b.className;
	if(cn.indexOf("night") == -1){
		b.className = cn + " night";
	};
	img_opacity = IMG_NIGHT_OPACITY;
	changeImgOpacity(img_opacity);
};

function showDayMode(){
	var b = document.querySelector("body");
	var cn = b.className;
	b.className = cn.replace("night","");
	img_opacity = 1;
	changeImgOpacity(img_opacity);
};

function showVideo(flag){
	if(flag == undefined) flag = 1;
	var con = document.querySelector(".video_player");
	if(con){
		if(!flag){
			con.style.background = "none";
			con.querySelector(".cover").style.display = "none";
			con.querySelector(".trigger").style.display = "none";
			con.querySelector(".text").style.display = "block";
		}else{
			con.style.background = "black";
			con.querySelector(".cover").style.display = "block";	
			con.querySelector(".trigger").style.display = "block";
			con.querySelector(".text").style.display = "none";
		};
	}
};

function showCustomVideo(){
	var len = videos.length;
	for(var i=0;i<len;i++){
		var video = videos[i],
			w = video.getAttribute('data-width'),
			h = video.getAttribute('data-height'),
			poster = video.getAttribute('data-poster'),
			ratio = 75;
		
		if(w && h){
			ratio = parseInt(100*h/w);
		}
		video.style.paddingBottom = ratio + '%';
		video.innerHTML = '<img src="' + poster + '" onload="appendVideoImg.call(this)" onerror="errorVideoImg.call(this)"/><i class="custom-video-trigger"></i>';
	}
}

function addBottomAds (imgsrc,jumpLink){
  var ele = document.createElement("div");
  ele.id = "btm_ads";
  ele.innerHTML = "<a href='"+jumpLink+"'><img src='"+imgsrc+"'/></a>";  
  document.getElementsByTagName("article")[0].appendChild(ele);
};

var infoInserted = false;
function insertDiv(obj){
	if(infoInserted) return;

	for(var k in obj){
		var con = document.querySelector("#"+k);
		if(con){
			con.innerHTML = obj[k];
			con.style.display = "block";
		}
	};
	infoInserted = true;
};

function hideBar(){ 
	document.querySelector(".bar").style.display = "none"; 
};

function showBar(){ 
	document.querySelector(".bar").style.display = "block"; 
};

function hideElement(ele){ 
	var e = document.querySelector(ele);
	if(e) e.style.display = "none"; 
};

function fixHref(){
	var links = document.querySelectorAll("[pro-href]");
	for(var i=0; i<links.length; i++){
		var h = links[i].getAttribute("pro-href");
		links[i].setAttribute("href",h);
	}
};

function fixSourceUrlHref() {
	var a = document.querySelector("footer #src a");
	if (a == null)
		return;
	var href = a.getAttribute("href");
	if (href == null)
		return;
	if (href.indexOf("http://") == 0 || href.indexOf("https://") == 0) {
		href = "bytedance://open_origin_url?url=" + encodeURIComponent(href);
		a.setAttribute("href", href);
	}
};

function request(paras){ 
	var url = location.href,
		paraObj = {};
	if(url.indexOf('?') > -1){
		var paraArray = url.substring(url.indexOf("?")+1,url.length).split("&");
		for(i = 0;i < paraArray.length;i++){
			var t = paraArray[i].split('=');
			paraObj[t[0].toLowerCase()] = t[1];
		}
	}
	return paraObj[paras.toLowerCase()];
};

function hash(){
	var s = location.hash.substr(1),
		hashQuery = {};
	
	if(s){
		var arr = s.split("&");
		for (var i = 0; i< arr.length; i++ ){
			var t = arr[i].split("=");
			hashQuery[t[0]] = t[1];
		};		
	};
	
	if(typeof arguments[0] == "string"){
		return hashQuery[arguments[0]];	
	};
	
	if(typeof arguments[0] == "object"){
		for(var k in arguments[0]){
			hashQuery[k] = arguments[0][k];
		}
		var s2 = "";
		for(var k in hashQuery){
			s2 += k+"="+hashQuery[k]+"&";
		};
		location.href = "#"+s2.substring(0,s2.length-1);
	};
};

var TouTiao = {
	showImage : function(type){
		show_images(type);
	},
	setFontSize : setFontSize,
	//日间,夜间模式 0夜间,1日间
	setDayMode : function(flag){
		if(["0","1",0,1].indexOf(flag) < 0 ) return;
		flag = parseInt(flag);
		flag ? showDayMode() : showNightMode();
	}
};

function hide_images(){
	// for (var i = 0; i < i_holders.length; i++) {
	// 	i_holders[i].style.display = "none";
	// 	t_holders[i].style.display = "block";
	// }
	if (trigger)
		trigger.style.display = "block";
	imageShown = false;
}

function toggle_images(opt){
	setTimeout(function() {
		do_toggle_images(opt);
	}, 100);
}

function do_toggle_images(opt){
	if(opt === 'show') {
		show_images('origin');
	} else if (opt === 'hide') {
		hide_images();
	} else {
		//imageShown === true ? hide_images():show_images('origin');
		if(imageShown){
			hide_images();
		}else{
			if(!close_lazyload){//2G、3G环境中，开启懒加载模式时，点击详情页“显示大图”
				from_thumb_to_large = true;
			}
			show_images('origin');
			document.removeEventListener('scroll',_pollImages);
			init_lazyload();
			_pollImages();
			document.addEventListener("scroll",_pollImages,false);
		}
	}
	setTimeout(function(){
		var event = "bytedance://toggle_image?action=";
		if (imageShown) {
			event += 'show'
		} else {
			event += 'hide'
		};
		window.location.href = event;
	}, 500);
}

//PGC订阅、点击统计事件
function  pgc_click_events(){
	var pgc_bar = document.querySelector('.pgc_bar');
	if(pgc_bar){
		pgc_bar.addEventListener("click",function(){window.location.href='bytedance://log_event?category=umeng&tag=detail&label=click_pgc_header';},false);
	}
	
	var profile_a = document.querySelector('#profile a');
	if(profile_a){
		profile_a.addEventListener("click",function(){window.location.href='bytedance://log_event?category=umeng&tag=detail&label=click_pgc_card';},false);
	}
}

//订阅回调
function subscribe_cb(o){
	var subscribed = has_elt_class(subscribe_btn,'subscribe_done');
	if(o.code == 1){//success
		toggle_subscribe_status(!subscribed);
	}
	del_elt_class(subscribe_btn,'subscribing');
	//toggle_subscribe_btn_status(false);
}

//切换订阅状态
function toggle_subscribe_status(subscribed){
	if(subscribed){
		subscribe_btn.innerHTML = '已订阅';
		add_elt_class(subscribe_btn,'subscribe_done');
	}else{
		subscribe_btn.innerHTML = '订阅';
		del_elt_class(subscribe_btn,'subscribe_done');
	}
}

//绑定订阅/取消订阅事件
function subscribe_click_events(){
	if(subscribe_btn){
		subscribe_btn.addEventListener('click',function(){
			var media_id = this.getAttribute('data-mediaid'),
				subscribed = has_elt_class(this,'subscribe_done'),
				subscribing = has_elt_class(this,'subscribing');
			if(subscribing){
				return;
			}
			add_elt_class(this,'subscribing');
			if(subscribed){
				window.ToutiaoJSBridge.call('do_media_unlike',{id:media_id},subscribe_cb);
			}else{
				window.ToutiaoJSBridge.call('do_media_like',{id:media_id},subscribe_cb);
			}
			//toggle_subscribe_btn_status(true);
		},false);
	}
}
//供服务端调用，确定是否需要显示订阅按钮、是否已订阅
function subscribe_switch(has_subscribed,host,args){
	if(profile){
		add_elt_class(profile,'show_subscribe');
		toggle_subscribe_status(has_subscribed);
	}
}
//注册订阅动作监听，负责其他页面的订阅动作同步到本页面
function set_subscribe_btn_status(o){
	var id = o.id,
		flag = o.status,
		local_id = subscribe_btn.getAttribute('data-mediaid');
	if(o.type == 'pgc_action' && id == local_id){
		toggle_subscribe_status(flag);
	}
}
window.addEventListener("load",function(){
	window.ToutiaoJSBridge.on("page_state_change", function(o){set_subscribe_btn_status(o);});
},false);

//
function video_click_events(){
	for(var i=videos.length -1;i>=0;i--){
		var video = videos[i];
		video.addEventListener('click',function(){playVideo(this,0)},false);
	}
}

//status:0 点击触发播放;1 滚入屏幕触发播放
function playVideo(that,status){
	var sp = that.getAttribute('data-sp'),
		vid = that.getAttribute('data-vid'),
		v_size = that.getAttribute('data-video-size'),
		coords = that.getBoundingClientRect(),
		frame = [
				coords.left,
				that.offsetTop,
				640,
				435
				];
	if(v_size){
		var obj = null;
		try{
			obj = JSON.parse(v_size);
		}catch(ex){}
		if(obj && obj.normal && obj.normal.h && obj.normal.w){
			frame[2] = obj.normal.w;
			frame[3] = obj.normal.h;
		}
	}
	window.ToutiaoJSBridge.call("playNativeVideo",{sp:sp,vid:vid,frame:frame,status:status},video_cb);
}
function video_cb(o){
	if(o.code == 1){
		var video = document.querySelector('[data-vid="'+o.vid+'"]');
		if(video){
			video.style.display = 'none';
			document.body.style.marginTop = o.height + 'px';
		}
	}
}

//判断视频是否处于屏幕可视区域
function _videoInView(element) {
	var coords = element.getBoundingClientRect(),
		video_height = coords.height || 100;
	return ((coords.top >= 0 && coords.left >= 0 && coords.top) <= (window.innerHeight || document.documentElement.clientHeight) - video_height);
}

//供服务端调用，开启自动播放功能，在首屏或者滚动到屏幕中的视频自动播放。每页面只自动播放第1个视频，后续视频忽略
function videoAutoPlay(){
	if(!autoplayed && videos.length){
		var firstVideo = videos[0];
		if(_videoInView(firstVideo)){
			playVideo(firstVideo,1);
			autoplayed = true;
		}else{
			document.addEventListener('scroll', videoAutoPlay);
		}
	}else{
		document.removeEventListener('scroll', videoAutoPlay);
	}
}

//关闭视频时，APP调用此函数通知web
function appCloseVideoNoticeWeb(vid){
	var video = document.querySelector('[data-vid="'+vid+'"]');
	if(video){
		video.style.display = 'block';
		document.body.style.marginTop = '0px';
	}
}